#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QtGui/QPaintEvent>
#include <QTimer>
#include <qgraphicsview.h>
#include <QPainter>

#define _cmd_stop       0
#define _cmd_forward    1
#define _cmd_backward   2
#define _cmd_left       3
#define _cmd_right      4
//
namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    int     valm1;
    int     valm2;
    int     valm3;
    int     valm4;
    int     wrvalm1;
    int     wrvalm2;
    int     wrvalm3;
    int     wrvalm4;
    int     wrhcam;
    int     wrvcam;
    int     hcam;
    int     vcam;
    int     cmd;
    bool    connected;
    //
    int     widht;
    int     height;
    int     swidht;
    int     sheight;
    char    dpix[640][480];

private slots:
    void on_b_forward_clicked();

    void on_b_stop_clicked();

    void on_b_backward_clicked();

    void on_b_left_clicked();

    void on_b_right_clicked();

    //void fdraw(void);
    void paintEvent(QPaintEvent *event);

    void test(void);

    void Vals(void);

    void on_bConnect_clicked();

    void on_pServNull_clicked();

private:
    //void Vals(void);
    QTimer *tmr;
    Ui::MainWindow  *ui;
    QGraphicsScene  *scene;
    QGraphicsView   *gView;
    QPixmap         *pix;
    QPainter        *paint;

};

#endif // MAINWINDOW_H
